//
//  TDES component demo
//  Copyright Cygron 1997
//

unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs,Des, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    ButtonEnc: TButton;
    ProgressBar1: TProgressBar;
    MemoIn: TMemo;
    MemoEnc: TMemo;
    MemoDec: TMemo;
    EditKey: TEdit;
    Label1: TLabel;
    ButtonDec: TButton;
    DES1: TDES;
    procedure FormCreate(Sender: TObject);
    procedure ButtonEncClick(Sender: TObject);
    procedure ButtonDecClick(Sender: TObject);
  public
    m_Path: String;
    procedure Code(f1,f2:String;coding: TDESCoding);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Code(f1,f2:String;coding: TDESCoding);
var
  input,output: TFileStream;
  buf,buf2: TDESBuffer;
  i: Longint;
  j,r: Integer;
begin
  Screen.Cursor := crHourglass;

  { set key }
  for i := 1 to Length(EditKey.Text) do buf[i] := Byte(EditKey.Text[i]);
  for i := Length(EditKey.Text)+1 to 8 do buf[i] := 0;

  DES1.SetKeyBuffer(buf,coding);

  input := TFileStream.Create(f1,fmOpenRead);
  output := TFileStream.Create(f2,fmCreate);

  ProgressBar1.Position := 0;
  i := 0;
  r := input.Read(buf,8);
  while r>0 do begin
    Inc(i,r);
    ProgressBar1.Position := Round(i/input.Size*100);
    for j := r+1 to 8 do buf[j] := 0;
    DES1.DESBuffer(buf,buf2);
    output.Write(buf2,8);
    r := input.Read(buf,8);
  end;
  ProgressBar1.Position := 0;

  input.Free;
  output.Free;
  Screen.Cursor := crDefault;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  m_Path := ExtractFilePath(Application.ExeName);
  MemoIn.Lines.LoadFromFile(m_Path+'test.in');
end;

procedure TForm1.ButtonEncClick(Sender: TObject);
begin
  ButtonDec.Enabled := TRUE;
  MemoIn.Lines.SaveToFile(m_Path+'test.in');
  Code(m_Path+'test.in',m_Path+'test.enc',dsEncode);
  MemoEnc.Lines.LoadFromFile(m_Path+'test.enc');
end;

procedure TForm1.ButtonDecClick(Sender: TObject);
begin
  Code(m_Path+'test.enc',m_Path+'test.dec',dsDecode);
  MemoDec.Lines.LoadFromFile(m_Path+'test.dec');
end;

end.
